'.----------+----------+--------- [MP3LinK] ---------+--------------------:
'|                           MP3LinK v1.10 by TuS                         |
':----------+----------+----------+-----------------+---------------------:

'**************************************************************************
'* Copyright (C) 2011                                                     *
'* TuS, tustus[at]hotmail[dot]com                                         *
'*                                                                        *
'* This program is free software; you can redistribute it and/or modify   *
'* it under the terms of the GNU General Public License as published by   *
'* the Free Software Foundation; either version 2 of the License, or      *
'* (at your option) any later version.                                    *
'*                                                                        *
'* This program is distributed in the hope that it will be useful, but    *
'* WITHOUT ANY WARRANTY; without even the implied warranty of             *
'* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                   *
'* See the GNU General Public License for more details.                   *
'*                                                                        *
'* You should have received a copy of the GNU General Public License      *
'* along with this program; if not, write to the                          *
'* Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,    *
'* MA 02111-1307 USA                                                      *
'**************************************************************************
'**************************************************************************
'* VBS Script logging Framework :                                         *
'* Copyright (C) 2006                                                     *
'* Christer Finsen, mind[underscore]trip[at]users[dot]sourceforge[dot]net *
'* Nils-Erik Aurker, nils-erik[at]users[dot]sourceforge[dot]net          *
'**************************************************************************

Option Explicit 

'Import Configuration
Import ("MP3LinK.Config")

'Make sure constants in Packer.config are correctlly defined
If TypeName(MP3LINK_PATHS) <> "String" _
	Or TypeName(ENABLE_BY_ARTIST) <> "Boolean" _
	Or TypeName(DIR_BY_ARTIST) <> "String" _
	Or TypeName(ENABLE_BY_GENRE) <> "Boolean" _
	Or TypeName(DIR_BY_GENRE) <> "String" _
	Or TypeName(ENABLE_BY_YEAR) <> "Boolean" _
	Or TypeName(DIR_BY_YEAR) <> "String" _
	Or TypeName(ENABLE_BY_GROUP) <> "Boolean" _
	Or TypeName(DIR_BY_GROUP) <> "String" _
	Or TypeName(USE_ALT_LIST) <> "Boolean" _
	Or TypeName(SCENEVIEW) <> "Boolean" _
	Or TypeName(WIDTH) <> "Integer" _
	Or TypeName(SCENEHEADER) <> "String" _
	Or TypeName(SCENESEPARATOR) <> "String" _
	Or TypeName(SCENETAIL) <> "String" _
	Or TypeName(NORMALHEADER) <> "String" _
	Or TypeName(NORMALSEPARATOR) <> "String" _
	Or TypeName(NORMALTAIL) <> "String" _
	Or TypeName(EVENTLOG) <> "Integer" _
	Or TypeName(FILELOG) <> "Integer" _
	Or TypeName(NUMBEROFLOGS) <> "Integer" Then
	WScript.echo "One or more required constants is not defined. Please see " _
	& "readme.txt for installation"
	WScript.quit
End If

'*********************************************************************************
'*********************************************************************************
'       DO NOT CHANGE THESE CONSTANTS UNLESS YOU KNOW WHAT YOU ARE DOING
'*********************************************************************************
Const APPNAME       = "TuS MP3LinK"
Const APPVERMAJOR   = "1"
Const APPVERMINOR   = "10"
Const AUTHOR        = "TuS"
Const COPYYEAR      = "2011"
Const FORREADING    = 1
Const FORWRITING    = 2
Const FORAPPENDING  = 8
Const SUCCESS       = 0
Const ERRORL        = 1
Const WARNING       = 2
Const INFORMATION   = 4
Const ABORT         = "Script aborted with error(s). To determine cause, see logged information"

'Script Root folder
Dim SCRIPTPATH : SCRIPTPATH = Left(WScript.ScriptFullName, InStrRev(WScript.ScriptFullName,"\")-1)
Dim SCRIPTNAME : SCRIPTNAME = Left(WScript.ScriptName, InStrRev(WScript.ScriptName,".")-1)
'Script Default parameters

'*********************************************************************************
'012345678901234567890123456789012345678901234567890123456789012345678901234567891

'#################################################################################
'	Main Entry Point
'#################################################################################
Dim currentSub : currentSub = "Main Code"
Dim sArgs, aFolders, sFolder, Item, scanItem
Dim oArgs : Set oArgs = WScript.Arguments

Dim tStartTime,tEndTime, tStepStartTime
Dim iCount, iCountAll, sCheck1, sCheck2, sCheck3

Const DEBUG_CLASS_EVENTS = true
Const FIRE_CLASS_EVENTS  = true

tStartTime = Now
'#-------------------------------------------------------------------------------#
'Load the framwork
'#-------------------------------------------------------------------------------#
'Init the Logger
Dim UserLog : Set UserLog = New UserLogClass
UserLog.LogEvent SUCCESS, "*** " & APPNAME & " " & APPVERMAJOR & "." & APPVERMINOR & " by " & AUTHOR & " ***"
UserLog.LogEvent SUCCESS, APPNAME & " Ver." & APPVERMAJOR & "." & APPVERMINOR & " Copyright(C) " & COPYYEAR
UserLog.LogEvent SUCCESS, APPNAME & " Ver." & APPVERMAJOR & "." & APPVERMINOR & " comes with ABSOLUTELY NO WARRANTY;"
UserLog.LogEvent SUCCESS, "This is free software, and you are welcome to redistribute it under certain" 
UserLog.LogEvent SUCCESS, "conditions; Read License.txt for details." 
UserLog.LogEvent SUCCESS, "VBS Script logging Framework: Copyright(C) 2006 Christer Finsen,and Nils-Erik Aurker" & vbnewLine

'Init the Helper
Dim Helper : Set Helper = New HelperClass

'Start the logger
UserLog.Start

'Init the CDDB
Dim CDDB : Set CDDB = New CDDBClass

'Init the Junction
Dim Junction : Set Junction = New JunctionClass
Junction.Path = SCRIPTPATH & "\Tools"

'Databases
Dim dScan, dJuncGENRE, dJuncARTIST, dJuncYEAR, dJuncGROUP
'Additions / Deletions DB's
Dim dJuncGENREAdd, dJuncGENREDel, dJuncARTISTAdd, dJuncARTISTDel, dJuncYEARAdd, dJuncYEARDel, dJuncGROUPAdd, dJuncGROUPDel
'
Dim remainKeys, tmpScanItem, tmpDBItem, dItem
' add/Del results
Dim addCount, delCount

'Set the collection objects
Set dScan = CreateObject("Scripting.Dictionary")
Set dJuncGENREAdd  = CreateObject("Scripting.Dictionary")
Set dJuncGENREDel  = CreateObject("Scripting.Dictionary")
Set dJuncARTISTAdd = CreateObject("Scripting.Dictionary")
Set dJuncARTISTDel = CreateObject("Scripting.Dictionary")
Set dJuncYEARAdd   = CreateObject("Scripting.Dictionary")
Set dJuncYEARDel   = CreateObject("Scripting.Dictionary")
Set dJuncGROUPAdd  = CreateObject("Scripting.Dictionary")
Set dJuncGROUPDel  = CreateObject("Scripting.Dictionary")
'#-------------------------------------------------------------------------------#

UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
UserLog.LogEvent SUCCESS, "[Main Code] Script Started"

'Debug Main Parameters
'UserLog.LogEvent SUCCESS, "[" & currentSub & "] " &  "Processing with "& oArgs.Count & " Input Arguments:"
'For iCnt = 0 To oArgs.Count -1 
'	If iCnt = 0 Then
'		sArgs = oArgs(iCnt)
'	Else
'		sArgs = sArgs & " ; " & oArgs(iCnt)
'	End if
'	UserLog.LogEvent INFORMATION, "[" & currentSub & "]   - Argument#" & iCnt+1 & ", Value=" & oArgs(iCnt)
'Next	
'UserLog.LogEvent SUCCESS, "[" & currentSub & "]   - Arguments: " & sArgs

aFolders = split(MP3LINK_PATHS, "|")

'Init the Counters
iCount = 0
iCountAll = 0

'Scan the folders and read ID3info
UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
tStepStartTime = now
For Each sFolder In aFolders
	UserLog.LogEvent SUCCESS, "[" & currentSub & "] Scanning Path ... : " & sFolder
	s_Scan  sFolder, true, dScan, true 
	'Update counters
	iCount = dScan.Count - iCountAll
	iCountAll = dScan.count
	UserLog.LogEvent SUCCESS, "[" & currentSub & "] Scanning Path Complete : Found "& iCount & " Albums."
Next 
UserLog.LogEvent SUCCESS, "[" & currentSub & "] Scanning Complete : Found Total "& iCountAll & " Albums. in " & Helper.ExecTime(tStepStartTime, now)
UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"

'Build the existing Junction point databases
s_BuildDB "BY_ARTIST", ENABLE_BY_ARTIST, DIR_BY_ARTIST, dJuncARTIST
s_BuildDB "BY_GENRE" , ENABLE_BY_GENRE , DIR_BY_GENRE , dJuncGENRE
s_BuildDB "BY_YEAR"  , ENABLE_BY_YEAR  , DIR_BY_YEAR  , dJuncYEAR
s_BuildDB "BY_GROUP" , ENABLE_BY_GROUP , DIR_BY_GROUP , dJuncGROUP

UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"

'Check scan and database results
tStepStartTime = Now
UserLog.LogEvent SUCCESS, "[" & currentSub & "] Comparing Scan and Databases ..."

'Compare the databases and scan
For Each scanItem In dScan.Keys
	s_CompareDBs  ENABLE_BY_ARTIST, "BY_ARTIST", dScan, dJuncARTIST, dJuncARTISTAdd, dJuncARTISTDel, scanItem 
	s_CompareDBs  ENABLE_BY_GENRE , "BY_GENRE" , dScan, dJuncGENRE , dJuncGENREAdd , dJuncGENREDel , scanItem 
	s_CompareDBs  ENABLE_BY_YEAR  , "BY_YEAR"  , dScan, dJuncYEAR  , dJuncYEARAdd  , dJuncYEARDel  , scanItem 
	s_CompareDBs  ENABLE_BY_GROUP , "BY_GROUP" , dScan, dJuncGROUP , dJuncGROUPAdd , dJuncGROUPDel , scanItem 
Next 
Set dScan = Nothing

'capture the remaining Deletes
For Each remainKeys In dJuncGENRE.Keys
	dJuncGENREDel.add remainKeys,dJuncGENRE.Item(remainKeys)

Next
Set dJuncGENRE = Nothing

For Each remainKeys In dJuncARTIST.Keys
	dJuncARTISTDel.add remainKeys,dJuncARTIST.Item(remainKeys)
next
Set dJuncARTIST = Nothing

For Each remainKeys In dJuncYEAR.Keys
	dJuncYEARDel.add remainKeys,dJuncYEAR.Item(remainKeys)
Next
Set dJuncYEAR = Nothing

For Each remainKeys In dJuncGROUP.Keys
	dJuncGROUPDel.add remainKeys,dJuncGROUP.Item(remainKeys)
Next
Set dJuncGROUP = Nothing

UserLog.LogEvent SUCCESS, "[" & currentSub & "]  - BY_ARTIST : " & dJuncARTISTAdd.Count & " Additions or Updates, " & dJuncARTISTDel.Count & " Deletions."
UserLog.LogEvent SUCCESS, "[" & currentSub & "]  - BY_GENRE  : " & dJuncGENREAdd.Count  & " Additions or Updates, " & dJuncGENREDel.Count  & " Deletions."
UserLog.LogEvent SUCCESS, "[" & currentSub & "]  - BY_YEAR   : " & dJuncYEARAdd.Count   & " Additions or Updates, " & dJuncYEARDel.Count   & " Deletions."
UserLog.LogEvent SUCCESS, "[" & currentSub & "]  - BY_GROUP  : " & dJuncGROUPAdd.Count  & " Additions or Updates, " & dJuncGROUPDel.Count  & " Deletions."

UserLog.LogEvent SUCCESS, "[" & currentSub & "] Comparing Scan and Databases Complete. In " & Helper.ExecTime(tStepStartTime, now)
UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
UserLog.LogEvent SUCCESS, "[" & currentSub & "] Building Directory structures ..."

'Process the BY_ARTIST Structure
tStepStartTime = Now 
addCount = 0
delCount = 0

delCount = f_DoDelete(DIR_BY_ARTIST, dJuncARTISTDel)
addCount = f_DoAdd("BY_ARTIST",DIR_BY_ARTIST,ENABLE_BY_ARTIST,dJuncARTISTAdd)
UserLog.LogEvent SUCCESS, "[" & currentSub & "] - BY_ARTIST Complete : Added or Updated: "& addCount & ", Deleted: " & delCount & ". In " & Helper.ExecTime(tStepStartTime, Now)

'Process the BY_Genre Structure
tStepStartTime = Now 
addCount = 0
delCount = 0

delCount = f_DoDelete(DIR_BY_GENRE, dJuncGENREDel)
addCount = f_DoAdd("BY_GENRE",DIR_BY_GENRE,ENABLE_BY_GENRE,dJuncGENREAdd)
UserLog.LogEvent SUCCESS, "[" & currentSub & "] - BY_GENRE Complete  : Added or Updated: "& addCount & ", Deleted: " & delCount & ". In " & Helper.ExecTime(tStepStartTime, Now)

'Process the BY_YEAR Structure
tStepStartTime = Now 
addCount = 0
delCount = 0

delCount = f_DoDelete(DIR_BY_YEAR, dJuncYEARDel)
addCount = f_DoAdd("BY_YEAR",DIR_BY_YEAR,ENABLE_BY_YEAR,dJuncYEARAdd)
UserLog.LogEvent SUCCESS, "[" & currentSub & "] - BY_YEAR Complete   : Added or Updated: "& addCount & ", Deleted: " & delCount & ". In " & Helper.ExecTime(tStepStartTime, Now)

'Process the BY_GROUP Structure
tStepStartTime = Now
addCount = 0
delCount = 0

delCount = f_DoDelete(DIR_BY_GROUP, dJuncGROUPDel)
addCount = f_DoAdd("BY_GROUP",DIR_BY_GROUP,ENABLE_BY_GROUP,dJuncGROUPAdd)
UserLog.LogEvent SUCCESS, "[" & currentSub & "] - BY_GROUP Complete  : Added or Updated: "& addCount & ", Deleted: " & delCount & ". In " & Helper.ExecTime(tStepStartTime, Now)

UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
UserLog.LogEvent SUCCESS, "[Main Code] Script Completed"
UserLog.DelLog

Function f_BuildSections (dItem)
		'**********************************************************************************
		' Purpose : Build the destination sections
		' Input   : aItem : the Item to process
		' Return  : array : The Sections Array
		'					0 - Genre, 1 - Artist, 2 - Year, 3 - Group						
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Main:f_BuildSections"
		Dim objRegExp : Set objRegExp = CreateObject("VBScript.RegExp")
		Dim aSections(3)
		Dim isOST, isVA
				
		On Error Goto 0
		
		'Build the By_Genre Section
		If (LCase(dItem(3)(0)) = "") then
			aSections(0) = "_Unknown"
		Else
			aSections(0) = Trim(dItem(3)(0))
		End If 
		
		'Build the By_Artist Section
		'Check OST
		With objRegExp 
	        .Pattern = "([\.|_|\-|\(|\s]+?o[\.|_|-|\s]*?s[\.|_|-|\s]*?t[\)|\.|_|\-|\s]+?|[\.|_|\-|\(|\s]*?soundtrack[\.|_|\-|\)|\s]+?)"
	        .IgnoreCase = True 
	        .Global = True 
	    End With 
	    isOST = objRegExp.Test(dItem(1)) 
		
		If isOST Then
			aSections(1) = "_OST"
		Else
			'Check VA
			With objRegExp 
		        .Pattern = "(^[\.|_|\-|\(]*?v[\.|_|-]*?a[\.|_|\-|\)]+?|[\.|_|\-|\(|\s]*?various[\.|_|\-|\)|\s]+?)"
		        .IgnoreCase = True 
		        .Global = True 
		    End With 
		    isVA = objRegExp.Test(dItem(1)) 
			If isVA Then
				aSections(1) = "_Various"
			Else
				If (LCase(dItem(3)(2)) = "") then
					aSections(1) = "_Unknown"
				Else
					aSections(1) = Englishizer(dItem(3)(2))	
				End If
			End If
		End If
		
		'Build the By_YEAR Section
		If (LCase(dItem(3)(1)) = "") then
			aSections(2) = "_Unknown"
		Else
			aSections(2) = dItem(3)(1)
		End If 
		
		'Build the By_GROUP Section
		If ((InStr(dItem(1), "-") = 0)) then
			aSections(3) = "_Unknown"
		Else
			aSections(3) = Englishizer(Trim(Right(dItem(1),Len(dItem(1)) - InStrRev(dItem(1), "-"))))
		End If 
		
		f_BuildSections = aSections
End function

Sub s_BuildDB (sSection, bEnabled, sRootDir, dJunc)
	'********************************************************************************
	' Purpose : Build the existant Junction point database
	' Input   : 
	'********************************************************************************

	tStepStartTime = Now
	If bEnabled Then
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] # " & sSection & " is Enabled."
	Else
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] # " & sSection & " is Disabled."
	End If
	UserLog.LogEvent SUCCESS, "[" & currentSub & "]  Building " & sSection & " Database ... : " & sRootDir
	If USE_ALT_LIST Then
		Set dJunc = Junction.GetJunctionListALT(sRootDir)
	Else
		Set dJunc = Junction.GetJunctionList(sRootDir)
	End if
	UserLog.LogEvent SUCCESS, "[" & currentSub & "]  - " & sSection & " Database : Found "& dJunc.Count & " entries. In " & Helper.ExecTime(tStepStartTime, Now)
End Sub

Sub s_CompareDBs (bEnabled, sSection, dScan, dJunc, dJuncAdd, dJuncDel, scanItem)
	'********************************************************************************
	' Purpose : Compare the scan and link DBs
	' Input   : 
	'********************************************************************************
	Dim currentSub : currentSub = "Class Main:s_CompareDBs"
	Dim tmpScanItem, tmpDBItem, bAdded, sTmpGenre, sTmpArtist, sTmpYear
	
	'set the default value
	bAdded = False
	
	If bEnabled Then
		If dJunc.exists(scanItem) Then
			'check if link is good
			tmpScanItem = dScan.Item(scanItem)
			tmpDBItem   = dJunc.Item(scanItem)
			
			'check the path
			If (tmpScanItem(2) <> tmpDBItem(2)) then
				dJuncAdd.add scanItem,tmpScanItem
				bAdded = True
			End If

			'check genre ID3 Tag change
			If ((sSection = "BY_GENRE") And Not(bAdded)) Then
				sTmpGenre = Replace(tmpDBItem(0),"\" & tmpDBItem(1),vbNullString)
				sTmpGenre = Right(sTmpGenre,Len(sTmpGenre) - InStrRev(sTmpGenre,"\"))
				If (sTmpGenre <> tmpScanItem(4)(0)) Then
					dJuncAdd.add scanItem,tmpScanItem
					bAdded = true
				End if
			End If

			'check Artist ID3 Tag change
			If ((sSection = "BY_ARTIST") And Not(bAdded)) Then
				sTmpArtist = Replace(tmpDBItem(0),"\" & tmpDBItem(1),vbNullString)
				sTmpArtist = Right(sTmpArtist,Len(sTmpArtist) - InStrRev(sTmpArtist,"\"))

				If (LCase(sTmpArtist) <> LCase(tmpScanItem(4)(1))) Then
					dJuncAdd.add scanItem,tmpScanItem
					bAdded = True
				End if
			End If
			
			'check Year ID3 Tag change
			If ((sSection = "BY_YEAR") And Not(bAdded)) Then
				sTmpYear = Replace(tmpDBItem(0),"\" & tmpDBItem(1),vbNullString)
				sTmpYear = Right(sTmpYear,Len(sTmpYear) - InStrRev(sTmpYear,"\"))

				If (LCase(sTmpYear) <> LCase(tmpScanItem(4)(2))) Then
					dJuncAdd.add scanItem,tmpScanItem
					bAdded = True
				End if
			End If
			
			If Not(bAdded) Then
				dJunc.Remove scanItem
			End If
		Else 
			dJuncAdd.add scanItem, dScan.Item(scanItem)
		End if
	Else
		If dJunc.exists(scanItem) Then
			dJuncDel.add scanItem,dJunc.Item(scanItem)
			dJunc.Remove scanItem
		End If
	End If
End Sub

function f_DoDelete(sSection, dJuncDel)
	'********************************************************************************
	' Purpose : Delete the links
	' Input   : 
	'********************************************************************************
	Dim currentSub : currentSub = "Class Main:f_DoDelete"
	Dim dItem, item, ret, delCount
	
	delCount = 0

	For Each Item In dJuncDel.Keys
		dItem = dJuncDel.Item(Item)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Processing : [" & dItem(0) & "]"
	    ret = Junction.DeleteJunction(dItem(0))
	    If ret = true Then
			delCount = delCount + 1
		Else 
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Unable to Delete junction : [" & dItem(0) & "]"
		End if
	    ret = Helper.DeleteEmptyFolders (Left(dItem(0), InStrRev(dItem(0), "\")),sSection) 
	Next 
	f_DoDelete = delCount
End Function

Function f_DoAdd(sSection,sSectionPath, bEnabled, dJuncAdd)
	'********************************************************************************
	' Purpose : Add the links
	' Input   : 
	'********************************************************************************
	Dim currentSub : currentSub = "Class Main:f_DoAdd"
	Dim dItem, item, ret, AddCount

	addCount = 0
	
	If bEnabled Then
		For Each Item In dJuncAdd.Keys
			dItem = dJuncADD.Item(Item)
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Processing : [" & sSection & "][" & sSectionPath & "][" & bEnabled & "][" & dItem(1) & "|" & dItem(2) & "|" & Join(dItem(4),"|") & "]"
						
			Select Case sSection
				Case "BY_GENRE"
					ret = Junction.CreateJunction(sSectionPath & "\" & dItem(4)(0) , dItem(1), dItem(2))
					If Not(ret) Then
						UserLog.LogEvent ERRORL, "[" & currentSub & "] Unable to create junction : [" & sSectionPath & "\" & dItem(4)(0) & "][" & dItem(1)& "][" & dItem(2) & "]"
					End If 
				Case "BY_ARTIST"
					If ((dItem(4)(1) = "_Various") Or (dItem(4)(1) = "_OST") Or (dItem(4)(1) = "_Unknown")) Then
						ret = Junction.CreateJunction(sSectionPath & "\" & dItem(4)(1) , dItem(1), dItem(2))
						If Not(ret) Then
							UserLog.LogEvent ERRORL, "[" & currentSub & "] Unable to create junction : [" & sSectionPath & "\" & dItem(4)(1) & "][" & dItem(1)& "][" & dItem(2) & "]"
						End If 
					Else
						ret = Junction.CreateJunction(sSectionPath & "\" & Englishizer(UCase(Left(dItem(4)(1),1))) & "\" & dItem(4)(1) , dItem(1), dItem(2))
					End If
				Case "BY_YEAR"
					ret = Junction.CreateJunction(sSectionPath & "\" & dItem(4)(2) , dItem(1), dItem(2))
					if Not(ret) Then
						UserLog.LogEvent ERRORL, "[" & currentSub & "] Unable to create junction : [" & sSectionPath & "\" & dItem(4)(2) & "][" & dItem(1)& "][" & dItem(2) & "]"
					End If 
				Case "BY_GROUP"
					ret = Junction.CreateJunction(sSectionPath & "\" & dItem(4)(3) , dItem(1), dItem(2))
					If Not(ret) Then
						UserLog.LogEvent ERRORL, "[" & currentSub & "] Unable to create junction : [" & sSectionPath & "\" & dItem(4)(3) & "][" & dItem(1)& "][" & dItem(2) & "]"
					End If 
			End Select
			
		    If ret = true Then
				AddCount = AddCount + 1
			End if 
		Next 
	End If
	f_DoAdd = AddCount 
End function


Sub s_Scan (sItemPath, bRecursive, dScan, bIsRoot)
		'********************************************************************************
		' Purpose : Scan folder starting from the current folder
		' Input   : sItemPath  : The path to search
		'           bRecursive : Should the function be recursive
		'			aScan      : array that will hold the scan results
		'           bIsRoot    : internal root check
		'********************************************************************************
		Dim currentSub : currentSub = "Class Main:s_Scan"
		On Error Resume next

		Dim oFolder, oSubFolders, oFiles, oItem, iCurSize, aItem, isMultiCD, isNotValid, IsSystem
		Dim objRegExp : Set objRegExp = CreateObject("VBScript.RegExp")
		'UserLog.LogEvent SUCCESS, "[" & currentSub & "] Scanning Path : " & sItemPath
		
		iCurSize = dScan.Count
		
		'Get the root folder
		Set oFolder = Helper.oFso.GetFolder(sItemPath)
		
		'Check the folder name For illegal caracters (should be ASCII 00-7F)
		With objRegExp 
	        .Pattern = "[\x00-\x1F\x7F-\xFF]+"
	        .IgnoreCase = True 
	        .Global = True 
	    End With 
	    isNotValid = objRegExp.Test(oFolder.Name) 
		
		If isNotValid Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Illegal Name detected: '" & oFolder.Name & "'. Skipping" 
			Exit Sub
		End If
		
		'Check the folder name system Folders
		If (LCase(oFolder.name) = "recycler") Or (LCase(oFolder.name) = "system volume information") then
	    	UserLog.LogEvent SUCCESS, "[" & currentSub & "] System folder detected: '" & oFolder.Name & "'. Skipping" 
			Exit Sub
	    End If 
		
		If Err.Number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Unable to connect to '" & sItemPath & "'." 
			Exit Sub
		Else 
			If not(bIsRoot) Then
				'Check for Files
				Set oFiles = oFolder.Files
				If oFiles.count > 0 Then

					'Check for MultiCD release
					If (lcase(Left(oFolder.Name,2)) = "cd") Or (lcase(Left(oFolder.Name,3)) = "Dis") then
						With objRegExp 
	                		.Pattern = "^CD[ ]*[0-9]+|^DISC[ ]*[0-9]+"
	                		.IgnoreCase = True 
	                		.Global = True 
	        			End With 
	        			isMultiCD = objRegExp.Test(oFolder.Name) 
					End if
					
					'Check for Files
					For each oItem In oFiles
						If (Right(oItem.Name,4) = ".mp3") Then
							'UserLog.LogEvent INFORMATION, "[" & currentSub & "] (" & iCurSize + 1 & ") Testing Item " & oItem.ParentFolder.Path 
							ReDim aItem(4)
							aItem(0) = oItem.Name
							
							'DebugBreak
							'If oItem.ParentFolder.Name = "Lenny Kravitz - MTV Unplugged-InD" Then
							'	WScript.Echo "Break:" &  oItem.ParentFolder.Name
							'End If 

							If isMultiCD Then
								If Not(dScan.Exists(oItem.ParentFolder.ParentFolder.Name)) Then
									'Store the parent name
									aItem(1) = oItem.ParentFolder.ParentFolder.Name
									aItem(2) = oItem.ParentFolder.ParentFolder.Path
									aItem(3) = CDDB.GetID3Info(oItem.Path) 
									aItem(4) = f_BuildSections(aItem) 
									ReDim Preserve aScan(iCurSize)
									dScan.add oItem.ParentFolder.ParentFolder.Name, aItem
									If aItem(3)(0) = "Unknown" then
										UserLog.LogEvent INFORMATION, "[" & currentSub & "] Unable to identify Genre " & oItem.Name & " Genre:" & aItem(3) & "|" & oID3.Genre
									End if
								Else
									UserLog.LogEvent INFORMATION, "[" & currentSub & "]  -> Allready Exists: (Multi CD) " & oItem.ParentFolder.ParentFolder.Name
								End if
								Exit For
							Else
								aItem(1) = oItem.ParentFolder.Name
								aItem(2) = oItem.ParentFolder.Path
								aItem(3) = CDDB.GetID3Info(oItem.Path)
								aItem(4) = f_BuildSections(aItem)  
								ReDim Preserve aScan(iCurSize)
								If Not(dScan.Exists(oItem.ParentFolder.Name)) Then
									dScan.add oItem.ParentFolder.Name, aItem
									If aItem(3)(0) = "Unknown" then
										UserLog.LogEvent INFORMATION, "[" & currentSub & "] Unable to identify Genre " & oItem.Name & " Genre:" & aItem(3) & "|" & oID3.Genre
									End If
								Else
									UserLog.LogEvent INFORMATION, "[" & currentSub & "]  -> Allready Exists: " & oItem.ParentFolder.Name
								End If 
								Exit For
							End If
						End if
					Next
				End If 
			End if
			
			'Recurse
			If bRecursive Then
				Set oSubFolders = oFolder.SubFolders
				For Each oItem In oSubFolders
					s_Scan  oItem.Path, true, dScan, False
				Next
			End if
		End If
End Sub

Function Englishizer(strIn)
    Dim strOut, strMid
    Dim n
    Dim objRegExp : Set objRegExp = CreateObject("VBScript.RegExp")
    Dim bMatch, oMatch, oMatchItem
    
    'Check For extended ascii caracters (should be ASCII 20-7E)
	With objRegExp 
	    .Pattern = "[^\x20-\x7E]"
	    .IgnoreCase = True 
		.Global = True 
	End With 

	Set oMatch = objRegExp.Execute(strIn) 
    For Each oMatchItem In oMatch
    	strMid = oMatchItem.value
    	Select Case Asc(strMid)
	        Case 145,146,180
	        	strMid = "'"
	        Case 138
	        	strMid = "S"
	        Case 140
	        	strMid = "OE"
	        Case 142
	        	strMid = "Z"
	        Case 154
	        	strMid = "s"
	        Case 156
	        	strMid = "oe"
	        Case 158
	        	strMid = "z"
	        Case 159
	        	strMid = "Y"
	        Case 192,193,194,195,196,197
	            strMid = "A"
	        Case 198
	            strMid = "AE"
	        Case 199
	            strMid = "C"
	        Case 200,201,202,203
	            strMid = "E"
	        Case 204,205,206,207
	            strMid = "I"
	        Case 208
	            strMid = "D"
	        Case 209
	            strMid = "N"
	        Case 210,211,212,213,214,216
	            strMid = "O"
	        Case 215
	            strMid = "x"
	        Case 217,218,219,220
	            strMid = "U"
	        Case 221
	            strMid = "Y"
	        Case 222, 254
	            strMid = "p"
	        Case 223
	            strMid = "B"
	        Case 224,225,226,227,228,229
	            strMid = "a"
	        Case 230
	            strMid = "ae"
	        Case 231
	            strMid = "c"
	        Case 232,233,234,235
	            strMid = "e"
	        Case 236,237,238,239
	            strMid = "i"
	        Case 240, 242,243,244,245,246,248
	            strMid = "o"
	        Case 241
	            strMid = "n"
	        Case 249,250,251,252
	            strMid = "u"
	        Case 253, 255
	            strMid = "y"
	        Case Else
	        	If Asc(strMid) > 127 Then
	        		strMid = "_"
	        	End If 
	        End Select
			'WScript.Echo oMatchItem.value & "|" & strMid
	        strIn = Replace(strIn, oMatchItem.value, strMid)
    Next

    Englishizer = strIn
End Function

'#################################################################################
'	Main Exit Point
'#################################################################################
'#################################################################################
' Class Wrapper for Junction Management
'#################################################################################
Class JunctionClass
	'Class vars
	Private	c_sPath,c_bLoaded
	'Function vars
	Public aOutput, str, aOutputelement, iCnt, iCnt2, arrList, iGetSize, sProcessTime
	Dim dJunctionList
	
	Dim oShell, Result, oFso
 
	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize
		c_sPath		 	= Left(WScript.ScriptFullName, InStrRev(WScript.ScriptFullName,"\")) & "Tools\"
		c_bLoaded		= true
		Set oShell		= CreateObject("Wscript.Shell")
		Set oFso		= CreateObject("Scripting.FileSystemObject")
	End Sub
	Private Sub Class_Terminate
		
	End Sub
	'#---------------------------------------------------------------------------#
	Public Property Get Path()
		Path = c_sPath
	End Property
	Public Property Let Path(sPath)
		If sPath <> vbNullString Then
			c_sPath = sPath
			c_bLoaded = ValidateConfig()
		End If 
	End Property
	Public Property Get Loaded()
		Loaded = c_bLoaded
	End Property
	Private Property Let Loaded(bLoaded)
		If (VarType(bLoaded) = vbBoolean) Then
			c_bLoaded = bLoaded
		End If 
	End Property
	'#---------------------------------------------------------------------------#
	
	Function CreateJunction(sPath, sTarget, sSource)
		'********************************************************************************
		' Puropose : Create a  Junction Point
		' Input    : sPath   : string : The Destination path
		'		   : sTarget : string : The Destination Target
		' 	         sSource : string : The Source path
		' Output   : integer : False : Error processing Command or sTarget Not Found
		'                    : True  : sTarget Junction point Deleted Successfully
		'********************************************************************************
		Dim currentSub : currentSub = "Class Junction:CreateJunction"
		
		If (c_bLoaded) Then
			If (Helper.CreateFolder (sPath)) then
				'Run the command
				aOutput = Helper.ShellRun(chr(34) & Chr(34) & c_sPath & "\linkd.exe" & Chr(34) & " " & Chr(34) & sPath & "\" & sTarget & Chr(34) & " " & Chr(34) & sSource & Chr(34) & chr(34),0,true)
						
				'Just for output debug
				'For Each aOutputelement In aOutput
			   	'	 UserLog.LogEvent INFORMATION, "[" & currentSub & "] " & aOutputelement
			   	'Next
						
				'Process output
				If UBound(aOutput) > 0 Then
					Select Case aOutput(0)
						Case "Link created at: " & sPath & "\" & sTarget '& vbCrlf
							UserLog.LogEvent INFORMATION, "[" & currentSub & "] " & Chr(34) & sPath & "\" & sTarget & Chr(34) & " : Junction point Created. " & aOutput(0) 
							CreateJunction = True
						Case Else
							UserLog.LogEvent ERRORL, "[" & currentSub & "] " & Chr(34) & sPath & "\" & sTarget & Chr(34) & " : " & aOutput(0)
							CreateJunction = False
					End Select
				Else
					'Default to error
					CreateJunction = False
				End If
	     	Else
				UserLog.LogEvent ERRORL, "[" & currentSub & "] " & "Junction Configuration Problem"
				CreateJunction = False
			End If
		Else
			UserLog.LogEvent ERRORL, "[" & currentSub & "] " & "Error creating Junction point"
			CreateJunction = False
		End If
	End Function 	

	Function DeleteJunction(sTargetPath)
		'********************************************************************************
		' Puropose : Delete an existant Junction Point
		' Input    : sTargetPath : string : The Full Path to the Target to delete
		' Output   : integer : False : Error processing Command or sTarget Not Found
		'                    :  True : sTarget Junction point Deleted Successfully
		'********************************************************************************
		Dim currentSub : currentSub = "Class Junction:DeleteJunction"
		
		If (c_bLoaded) Then
			
				aOutput = Helper.ShellRun(chr(34) & Chr(34) & c_sPath & "\linkd.exe" & Chr(34) & " " & Chr(34) & sTargetPath & Chr(34) & " /d" & chr(34),0,true)

				'Just for output debug
				'For Each aOutputelement In aOutput
		   		'	 UserLog.LogEvent INFORMATION, "[" & currentSub & "] " & aOutputelement & vbcrlf
		   		'Next
				
				'Process output
				If UBound(aOutput) > 0 Then
					Select Case aOutput(0)
						Case "The delete operation succeeded." & vbcr
							UserLog.LogEvent INFORMATION, "[" & currentSub & "] " & "Junction point Deleted." & " : " & aOutput(0)
							DeleteJunction = True
						Case Else
							UserLog.LogEvent ERRORL, "[" & currentSub & "] " & "Unable to delete Junction point" & " : " & aOutput(0)
							DeleteJunction = False
					End Select
				Else
					'Default to error
					DeleteJunction = False
				End If
			Else
				UserLog.LogEvent ERRORL, "[" & currentSub & "] " & "Junction Configuration Problem"		
				DeleteJunction = False
			End if
	End Function 

	Function GetJunctionList(sPath)
		'********************************************************************************
		' Puropose : Check if is the Target is a NTFS Junction
		' Input    : sPath   : string : The path to Junction
		' Output   : integer : dict dJunc
		'********************************************************************************
		Dim currentSub : currentSub = "Class Junction:GetJunctionList"
		'UserLog.LogEvent INFORMATION, "[" & currentSub & "] " & Chr(34) & sPath & Chr(34) & " -------------- Started."
						
		Dim sTempFile, sCmd, cmdOutput, iPos

		Dim aItem(2), dJunctionList, sStream, sTmpJuncLine, sTmpStr
		
		Set dJunctionList = CreateObject("Scripting.Dictionary")
		
		sTempFile = Helper.GetTempFilename
		
		sCmd = chr(34) & c_sPath & "\junction.exe" & chr(34) & " -s " & Chr(34) & sPath & Chr(34)
		oShell.run "%comspec% /c " & chr(34) & sCmd & " > " & sTempFile & chr(34),0,True
	
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Command Execute (Wait): [" &sCmd  & " > " & sTempFile & "]"
		
		If Helper.FileExists(sTempFile,False) Then
			'sTempFile = "C:\Program Files\RaidenFTPd\addons\Dev\MP3Link\Temprad831D0.tmp"
			
			On Error Resume Next
			sStream = oFso.OpenTextFile(sTempFile,1).ReadAll
			cmdOutput = Split(sStream,vbCRLF)
			sStream = ""
			If Err.Number <> 0 Then
				Helper.EchoErr Err, currentSub
				If Err.Number = 7 Then
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Out of Memory Error, unable to list existing junction points, you may have to consider adding more memory to your system."
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Script will continu execution but consider no junction points exist."
				End if
				UserLog.LogEvent ERRORL, "[" & currentSub & "] Error Reading Output result from Command Execute"
				Err.Clear
			Else
				'Just Debug
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Command has Output."
				'just For debug
				'For iCnt = 0 To UBound(cmdOutput)
				'	UserLog.LogEvent INFORMATION, "[" & currentSub & "] -" & cmdOutput(iCnt)
				'Next
			End If
			'oFso.DeleteFile sTempFile, true
		Else
			UserLog.LogEvent ERRORL, "[" & currentSub & "] No Output File from Command Execute"
		End If  
	
		'Process the output
		For iCnt=5 To UBound(cmdOutput)-1
			 'UserLog.LogEvent INFORMATION, "[" & currentSub & "] " & cmdOutput(iCnt)
	
			sTmpJuncLine = cmdOutput(iCnt)

			'Bug in junction.exe output (adds one or several "." and some 'CR' (Carriage Return) at the begening of the line randomly??
			iPos = InStr(sTmpJuncLine,"\\?\")
			If iPos > 1 Then
				sTmpJuncLine = Right(sTmpJuncLine, Len(sTmpJuncLine) - iPos +1)
			End If 

			If (InStr(sTmpJuncLine,"\\?\")) Then
				sTmpStr = Replace(Replace(sTmpJuncLine,": JUNCTION",vbNullString),"\\?\",vbNullString)

				aItem(0) = sTmpStr
			 	sTmpStr = Right(aItem(0),Len(aItem(0)) - InStrRev(aItem(0),"\"))
			 	aItem(1) = sTmpStr
			 	sTmpJuncLine = cmdOutput(iCnt+2)
			 	sTmpStr = replace(sTmpJuncLine,"   Substitute Name: ",vbNullString) 'this is linkd format
			 	aItem(2) = sTmpStr
			 	dJunctionList.add aItem(1), aItem 
			 	Erase aItem
			 	'jump to next entry
			 	iCnt = iCnt + 3 'this is linkd format
			 End if
		Next

		'Return
		Set GetJunctionList = dJunctionList
		
		'Reset objects
		Set dJunctionList = nothing
		Set cmdOutput = Nothing
		sStream = ""
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Junction Points found : " & dJunctionList.Count
	End Function 	

	Function GetJunctionListALT(sPath)
		'********************************************************************************
		' Puropose : Check if is the Target is a NTFS Junction
		' Input    : sPath   : string : The path to Junction
		' Output   : integer : dict dJunc
		'********************************************************************************
		Dim currentSub : currentSub = "Class Junction:GetJunctionListALT"
		'UserLog.LogEvent INFORMATION, "[" & currentSub & "] " & Chr(34) & sPath & Chr(34) & " -------------- Started."
						
		Dim sTempFile, sCmd, cmdOutput, iPos
		Dim aItem(2), dJunctionList
		Dim outFile, sTmpJuncLine
		
		Set dJunctionList = CreateObject("Scripting.Dictionary")
		
		sTempFile = Helper.GetTempFilename
		
		sCmd = chr(34) & c_sPath & "\junction.exe" & chr(34) & " -s " & Chr(34) & sPath & Chr(34)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Command Execute (Wait): [" &sCmd  & " > " & sTempFile & "]"
		
		oShell.run "%comspec% /c " & chr(34) & sCmd & " > " & sTempFile & chr(34),0,True
	
		If Helper.FileExists(sTempFile,False) Then
			
			On Error Resume Next
			Set outFile = oFso.OpenTextFile(sTempFile,1)
			
			If Err.Number <> 0 Then
				Helper.EchoErr Err, currentSub
				if Err.Number = 7 Then
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Out of Memory Error, unable to list existing junction points, you may have to consider adding more memory to your system."
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Script will continu execution but consider no junction points exist."
				End if
				UserLog.LogEvent ERRORL, "[" & currentSub & "] No Output result from Command Execute"
				Err.Clear
			Else
				'Just Debug
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Command has Output."
			End If
		Else
			UserLog.LogEvent ERRORL, "[" & currentSub & "] No Output File from Command Execute"
		End If  
	
		'Process the output
		'skip header
		iCnt = 0
		While (iCnt < 5 and Not(outFile.AtEndOfStream))
			outFile.SkipLine 
			iCnt = iCnt + 1
		Wend 
		
		While Not(outFile.AtEndOfStream)
			sTmpJuncLine = 	outFile.ReadLine
			'UserLog.LogEvent INFORMATION, "[" & currentSub & "] " & sTmpJuncLine
		
			'Bug in junction.exe output (adds one or several "." and some 'CR' (Carriage Return) at the begening of the line randomly??
			iPos = InStr(sTmpJuncLine,"\\?\")
			If iPos > 1 Then
				sTmpJuncLine = Right(sTmpJuncLine, Len(sTmpJuncLine) - iPos +1)
			End If 
		
			If (InStr(sTmpJuncLine,"\\?\")) then
			 	aItem(0) = Replace(Replace(sTmpJuncLine,": JUNCTION",vbNullString),"\\?\",vbNullString)
			 	aItem(1) = Right(aItem(0),Len(aItem(0)) - InStrRev(aItem(0),"\"))
			 	outFile.SkipLine 'this is linkd format
			 	
			 	aItem(2) = replace(outFile.ReadLine,"   Substitute Name: ",vbNullString) 'this is linkd format
			 	dJunctionList.add aItem(1), aItem 
			 	'jump to next entry
			 	outFile.SkipLine 'this is linkd format
			 End if
		wend
		
		'Close and delete the temp file
		outFile.Close
		oFso.DeleteFile sTempFile, true
		If Err.Number <> 0 Then
			Helper.EchoErr Err, currentSub
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Unable to delete Temp file :" & sTempFile & ". Please delete it manually."
			Err.Clear
		Else
			'Just Debug
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Command output file deleted : " & sTempFile & "."
		End If

		Set cmdOutput = Nothing
		Set GetJunctionListALT = dJunctionList
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Junction Points found : " & dJunctionList.Count
	End Function 	
	
	Function ValidateConfig()
		'********************************************************************************
		' Puropose : Validate the Utility Configuration
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class Junction:ValidateConfig()"
		
		'check that junction executable exists
		ValidateConfig = Helper.FileExists(Junction.Path & "\junction.exe", True)
		If ValidateConfig Then
			ValidateConfig = Helper.FileExists(Junction.Path & "\linkd.exe", True)
		End If 
		If ValidateConfig = False Then
			Helper.Terminate
		End If 
	End Function 
End Class

'######################################################################################
' Class Wrapper for CDDB
'######################################################################################
Class CDDBClass
	'Class vars
	Private	c_bLoaded
	'Class objects
	Public oShell, oFso, oID3
	'Genrelist
	Public genreListStr, genreList
	'Function vars
	Public Return
	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize
		Dim currentSub : currentSub = "Class CDDB:Class_Initialize"
		On error Resume next
		Set oFso	= CreateObject("Scripting.FileSystemObject")
		Set oShell	= CreateObject("Wscript.Shell")
		Err.Clear
		Set oID3    = CreateObject("CDDBControl.CddbID3Tag")
		
		If Err.Number = 429 Or IsEmpty(oID3) Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] CDDBControl is not registered: " & Err.description & " (" & Err.number & ")"
			Initialize
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] CDDBControl is registered."
			c_bLoaded = true
		End if
		genreListStr = "Blues,Classic Rock,Country,Dance,Disco,Funk,Grunge,Hip-Hop,Jazz,Metal," _
					   & "New Age,Oldies,Other,Pop,R&B,Rap,Reggae,Rock,Techno,Industrial,Alternative," _
					   & "Ska,Death Metal,Pranks,Soundtrack,Euro-Techno,Ambient,Trip-Hop,Vocal,Jazz+Funk,Fusion," _
					   & "Trance,Classical,Instrumental,Acid,House,Game,Sound Clip,Gospel,Noise,Alternative Rock," _
					   & "Bass,Soul,Punk,Space,Meditative,Instrumental Pop,Instrumental Rock,Ethnic,Gothic,Darkwave," _
					   & "Techno-Industrial,Electronic,Pop-Folk,Eurodance,Dream,Southern Rock,Comedy,Cult,Gangsta,Top 40," _
					   & "Christian Rap,Pop/Funk,Jungle,Native American,Cabaret,New Wave,Psychadelic,Rave,Showtunes,Trailer," _
					   & "Lo-Fi,Tribal,Acid Punk,Acid Jazz,Polka,Retro,Musical,Rock & Roll,Hard Rock,Folk," _
					   & "Folk-Rock,National Folk,Swing,Fast Fusion,Bebob,Latin,Revival,Celtic,Bluegrass,Avantgarde," _
					   & "Gothic Rock,Progressive Rock,Psychedelic Rock,Symphonic Rock,Slow Rock,Big Band,Chorus,Easy Listening,Acoustic,Humour," _
					   & "Speech,Chanson,Opera,Chamber Music,Sonata,Symphony,Booty Bass,Primus,Porn Groove,Satire," _
					   & "Slow Jam,Club,Tango,Samba,Folklore,Ballad,Power Ballad,Rhythmic Soul,Freestyle,Duet," _
					   & "Punk Rock,Drum Solo,Acapella,Euro-House,Dance Hall,Goa,Drum & Bass,Club - House,Hardcore,Terror," _
					   & "Indie,BritPop,Negerpunk,Polsk Punk,Beat,Christian Gangsta Rap,Heavy Metal,Black Metal,Crossover,Contemporary Christian," _
					   & "Christian Rock,Merengue,Salsa,Thrash Metal,Anime,JPop,SynthPop"
		genreList  = split(genreListStr,",")
		On error Goto 0
	End Sub
	
	Private Sub Class_Terminate
		Set oFso	= Nothing
		Set oShell	= Nothing
	End Sub
	'#---------------------------------------------------------------------------#
	Public Property Get Loaded()
		Loaded = c_bLoaded
	End Property
	'#---------------------------------------------------------------------------#
	Public Function GetID3Info(sFilePath)
		'**********************************************************************************
		' Purpose : Query and return the ID3Info for the file
		' Input   : SFilePath : the full path to the file
		' Return  : array : The file ID3Info
		'					0 - Genre, 1 - Year, 2 - Artist, 3 - Group	
		'**********************************************************************************
		Dim currentSub : currentSub = "Class CDDB:getID3Info"
		Dim aItem(3), oID3Info
		On Error Goto 0
		oID3Info = oID3.LoadFromFile(sFilePath,1)
		aItem(0) = FixGenre(oID3.Genre)
		aItem(1) = FixYear(oID3.Year)
		aItem(2) = FixStr(oID3.LeadArtist)
		aItem(3) = FixStr(oID3.Album)
		GetID3Info = aItem
		'UserLog.LogEvent INFORMATION, "[" & currentSub & "] ID3Tag Info : [" & oID3.Genre & "|" & oID3.Year &  "|" & oID3.LeadArtist & "|" & oID3.Album & "]"
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] ID3Tag Info Fixed: [" & Join(aItem,"|")& "]"
	End Function
	
	Private Function FixStr(ByVal sStr)
		'**********************************************************************************
		' Purpose : Fix string to Ucase every 1st letter of each word
		' Input   : sStr  : the string to process
		' Return  :       : The prossesed string
		'**********************************************************************************
		Dim currentSub : currentSub = "Class CDDB:FixStr"
		Dim aStr, sItem, iCnt, aList, sListItem, n , strAsc
		Dim objRegExp : Set objRegExp = CreateObject("VBScript.RegExp")
		
		'UserLog.LogEvent INFORMATION, "[" & currentSub & "] Info Input : [" & sStr & "]"

		'Remove extended ascii caracters
		sStr = Englishizer(Trim(sStr))
		
		'Capitalize first letter of each word
		aList = Split(" |-|_|(|)|[|]|&|,|;","|")
		If Len(sStr) > 0 Then
			sStr = Replace(sStr,Mid(sStr,1,1),UCase(Mid(sStr,1,1)),1,1)
			For Each sListItem In aList
				'Ucase the word when sListItem
				If InStr(sStr,sListItem) > 0 Then
					'WScript.Echo "-Processing:[" & sListItem &"]"
					aStr = Split(sStr,sListItem)
					iCnt = 0
					For Each sItem In aStr 
						sItem = Replace(sItem,Mid(sItem,1,1),UCase(Mid(sItem,1,1)),1,1)
						aStr(iCnt) = sItem
						iCnt = iCnt + 1
					Next
					sStr = Join(aStr,sListItem)
				End If
			Next 
			
			'Remove Unallowed chars
			sStr = Replace(sStr," ", "_")
			sStr = Replace(sStr,"/", "-")
			sStr = Replace(sStr,"\", "-")
			sStr = Replace(sStr,"*", "-")
			sStr = Replace(sStr,":", "-")
			sStr = Replace(sStr,"?", "-")
			sStr = Replace(sStr,"<", "-")
			sStr = Replace(sStr,">", "-")
			sStr = Replace(sStr,"|", "-")
			sStr = Replace(sStr,Chr(34), "-")
			
			'Remove some other chars
			sStr = Replace(sStr,"(", "")
			sStr = Replace(sStr,")", "")
			sStr = Replace(sStr,"[", "")
			sStr = Replace(sStr,"]", "")
			sStr = Replace(sStr,"{", "")
			sStr = Replace(sStr,"}", "")
			
			'remove any bad leading and tailing caracters
			With objRegExp 
			    .Pattern = "^[^a-zA-Z0-9]+|[^a-zA-Z0-9]+$"
			    .IgnoreCase = True 
				.Global = True 
			End With 
			sStr = objRegExp.replace(sStr,"") 
			
		End If
		'UserLog.LogEvent INFORMATION, "[" & currentSub & "] Info Output : [" & sStr & "]"
		If sStr = "" Then
			FixStr = ""
		Else
			FixStr = sStr
		End If
	End Function
	
	public Function FixYear (ByVal sYear)
		'**********************************************************************************
		' Purpose : Fix the year
		' Input   : sYear  : the year string to process
		' Return  :        : The year prossesed string
		'**********************************************************************************
		Dim objRegExp : Set objRegExp = CreateObject("VBScript.RegExp")
		Dim bYearMatch
		On Error Resume next
		
		'Default to Unknown
		FixYear = ""
		
		'trim any spaces
		sYear = Trim(sYear)
		
		'check if valid
		If TypeName(CInt(sYear)) = "Integer" Then
			If Err.Number = 0 Then
				
				'limit To first 4 digits
				sYear = Left(sYear,4)
				
				'match 4 digit year 1900-2099
				With objRegExp 
				    .Pattern = "^(19|20)[0-9]{2}$"
				    .IgnoreCase = True 
					.Global = True 
				End With 
				bYearMatch = objRegExp.Test(sYear) 
				
				If bYearMatch Then
					FixYear = sYear
				End If 
			End if
		End If
	End Function
	
	Private Function FixGenre (ByVal sGenre)
		'**********************************************************************************
		' Purpose : Fix the genre and check against standard ID3 genres
		' Input   : sGenre  : the Genre string to process
		' Return  :         : The Genre prossesed string
		'**********************************************************************************
		Dim iGenre
		On Error Resume Next 
		
		'Default to Unknown
		FixGenre = ""
		
		'trim any spaces
		sGenre = LTrim(rtrim(sGenre))
		'WScript.Echo sGenre	
		If InStr(sGenre,"(") > 0 Then
			iGenre = CInt(Mid(sGenre,InStr(sGenre,"(")+1,InStr(sGenre,")")-InStr(sGenre,"(")-1))
			If TypeName(iGenre) = "Integer" Then
				FixGenre = genreList(iGenre)
				Exit function
			End If 
		Else 
			sGenre = Replace(LCase(sGenre),"avant-garde","Avantgarde")
			
			Dim strList : strList = lcase("," & genreListStr & ",")
			
			If InStr(strList ,"," & lcase(sGenre) & ",") > 0 Then
				Dim iStart : iStart = InStr(strList,"," & LCase(sGenre) & ",")
				Dim iEnd   : iEnd   = InStr(iStart+1,strList,",")
			
				FixGenre = Mid("," & genreListStr & ",",iStart+1,iEnd-iStart-1)
				Exit function
			End If 
		End If 
	End Function
	
	Private Sub Initialize()
		'********************************************************************************
		' Purpose : Try to register the CDDBControl.dll
		' Input   : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CDDB:Initialize"
				
		On Error Resume Next
		Err.clear
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Trying to register " & Chr(34) & SCRIPTPATH & "\Tools\CDDBControl.dll"
		Return = oShell.Run("%comspec% /c " & Chr(34) & "regsvr32.exe /s " & Chr(34) & SCRIPTPATH & "\Tools\CDDBControl.dll" & Chr(34) & Chr(34), 0, true)
		
		If Return <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to register CDDBControl.dll. The Return code was (" & Return & ")"
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Registration of CDDBControl.dll is mandatory. Please try to register it manually."
			WScript.Quit
		Else
			Set oID3 = CreateObject("CDDBControl.CddbID3Tag")
			If Err.Number = 0 Then
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] CDDBControl.dll was successfully registered."
				c_bLoaded = true
			Else
				UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to register CDDBControl.dll. The error was : " & Err.description & " (" & Err.number & ")"
				UserLog.LogEvent ERRORL, "[" & currentSub & "] Registration of CDDBControl.dll is mandatory. Please try to register it manually."
				UserLog.LogEvent ERRORL, "[" & currentSub & "] If you are running a 64Bit OS be sure to use the 32Bit C:\Windows\SysWOW64\cscript.exe."
				WScript.Quit
			End if
		End If
	End Sub	
End Class

'######################################################################################
' Class Wrapper for Logging
'######################################################################################
Class UserLogClass
	
	Private bLoaded, bLogActive
	Private	sLogRoot,sLogFilePre,sLog
	Private oShell,oFso,oRegEx,oLog,oFldr,oFile
	Private iLogToKeep,iArr,iCnt,n,m,temp
	Private	aLog,aDate()
	Private cFiles
	
	Private Sub Class_Initialize
		'#--------------------------------------------------------------------------------#
		' Purpose : Class Initialisation
		'#--------------------------------------------------------------------------------#	
		iLogToKeep	= NUMBEROFLOGS
		bLoaded		= False
		bLogActive	= False
		sLogRoot 	= SCRIPTPATH & "\Log"
		sLogFilePre = SCRIPTNAME & "-" 
		Set oShell 	= WScript.CreateObject("Wscript.Shell")
		Set oFso	= CreateObject("Scripting.FileSystemObject")
		'LogEvent SUCCESS, "Log System: Copyright (C) 2006 Christer Finsen,and Nils-Erik Aurker" & vbnewLine
	End Sub
	
	Private Sub Class_Terminate
		'#--------------------------------------------------------------------------------#
		' Purpose : Class Terminate
		'#--------------------------------------------------------------------------------#	
		Dim currentSub : currentSub = "Class UserLog:Class_Terminate"
		
		'Clean up the logs
		'DelLog
		
		Set oFso	= Nothing
		Set oShell	= Nothing
	End Sub
	
	Public Property Get LogPath()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogPath = sLogRoot
	End Property
	
	Public Property Let LogPath(sPath)
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	If sPath <> vbNullString Then
		sLogRoot = sPath
	End If 
	End Property
	
	Public Property Get LogActive()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogActive = bLogActive
	End Property
	
	Public Property Get LogsToKeep()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogsToKeep = iLogToKeep
	End Property
	
	Public Property Let LogsToKeep(iValue)
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	If (VarType(iValue) = vbInteger) Then
		iLogToKeep = iValue
	End If 
	End Property
	
	Public Property Get LogFile()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogFile = sLog
	End Property
	
	Public Function Start()
		'**********************************************************************************
		' Purpose : Initialize the Log interface, check log path
		'           Easily extend logging into other formats, Ex : Syslog, mail, xml etc.
		' Input   : none
		' Return  : bool	: True|False
		'**********************************************************************************
		Dim currentSub : currentSub = "Class UserLog:Initialize"
		
		If (Helper.CreateFolder(sLogRoot) = False) Then
			LogEvent ERRORL, ABORT
			WScript.quit
		End If
		
		sLog = sLogRoot & "\" & sLogFilePre & Helper.GetDayTimeDate() & ".log"
		If (oFso.FileExists(sLog)) Then
			LogEvent INFORMATION, "[" & currentSub & "] The logfile: " & sLog & " allready exists. Appending random number to name of logfile"
			sLog = sLogRoot & sLogFilePre & Helper.GetDayTimeDate() & "_" & Helper.Random(9999) & ".log"
		End If
		
		LogEvent INFORMATION, "[" & currentSub & "] Logfile = " & sLog
		
		bLogActive = True
	End Function
	
	Public Sub LogEvent(eventType, sMessage)
		'**********************************************************************************
		' Purpose : Log interface, write various type of events to different formats, 
		'			NT Event, File etc.
		'           Easily extend logging into other formats, Ex : Syslog, mail, xml etc.
		' Input   : i : Event type, Integer 0 = None 1 = Success/Error 2 = Full
		'           sMessage : Log message, String
		'**********************************************************************************
		'Eventlog output
		If EVENTLOG = 1 Or EVENTLOG = 2 Then
			Set oRegEx = New RegExp
			'oRegEx.Pattern = "\[.*\] "
			'Changed to be able to print message file output when Message contains Brackets]
			oRegEx.Pattern = "^(\[[^*\]]*\])+"
			sMessage = oRegEx.Replace (sMessage, "")
			doEventLog eventType, Trim(sMessage)
			Set oRegEx = Nothing
		End If
		
		'Debug EventLog output
		If EVENTLOG = 3 Then
			doEventLog eventType, sMessage
		End If
		
		'Logfile output
		If FILELOG = 1 Or FILELOG = 2 Then
			Set oRegEx = New RegExp
			'oRegEx.Pattern = "\[.*\] "
			'Changed to be able to print message file output when Message contains Brackets]
			oRegEx.Pattern = "^(\[[^*\]]*\])+"
			sMessage = oRegEx.Replace (sMessage, "")
			doFileLog eventType, Trim(sMessage)
			Set oRegEx = Nothing
		End If
		
		'Debug logfile output
		If FILELOG = 3 Then
			doFileLog eventType, sMessage
		End If	
		
		'Debug screen output
		If FILELOG = 3 Or EVENTLOG = 3 Then
			WScript.echo sMessage
		End If
	End Sub
	
	Private Sub doFileLog(eventType, sMessage)
		'**********************************************************************************
		' Purpose : Write Event to logfile. Build an array of events until path logfile 
		'			is determined.
		'           If logfile can not be written. Events are redirected to eventlog.
		'           EventLog Level 0 = None 1 = Success/Error 2 = Full
		' Input   : eventType : Event type, Integer
		'           0 SUCCESS	1 ERROR (Const ERRORL)	2 WARNING	4 INFORMATION
		'           s : Log message, String
		' Use     : bLog Boolean True|False when actually start logging to file
		'**********************************************************************************
		On Error Resume Next
		
		Dim currentSub : currentSub = "Class UserLog:FileLog"
		
		'WScript.Echo eventType & " : " & sMessage
		'Make sure errorlevel 0
		Err.clear
		
		'Log to file if bLog flag is true
		If bLogActive = True Then
			
			Set oLog = oFso.OpenTextFile(sLog, FORAPPENDING, True)
			
			If Err.number <> 0 Then
				Helper.EchoErr Err, currentSub
				'Clear error
				Err.clear
				'Check if log folder exists, try to create
				If Helper.CreateFolder(Left(sLog, InStrRev(sLog, "\"))) <> -1 Then
					Set oLog = oFso.OpenTextFile(sLog, FORAPPENDING, True)
					
				Else
					
					'Abort filelog operation if can't be written, switch to EventLog	
					EVENTLOG = 2
					FILELOG = 0
					Err.Raise = iErr
					LogEvent ERRORL, "[" & currentSub & "] Error occured while writing to logfile: " & sLog & ". The error was: " & Err.description
					LogEvent WARNING, "[" & currentSub & "] Events will permanently be redirected to eventlog. All events occured prior to this warning will now be written."
					
					'Write events from array to eventlog
					If IsArray(aLog) And aLog(0) <> vbNullString Then
						For iArr = 0 To UBound(aLog)
							LogEvent CInt(Left(aLog(iArr), 1)), Right(aLog(iArr), Len(aLog(iArr)) - 1)
						Next
						
						ReDim aLog(0)	
					End If
					
					Exit Sub
				End If
			End If
			
			'Write events from array to logfile
			If IsArray(aLog) And aLog(0) <> vbNullString Then
				For iArr = 0 To UBound(aLog)
					oLog.WriteLine Right(aLog(iArr), Len(aLog(iArr)) - 1)
				Next
				
				ReDim aLog(0)
			End If
			
			Select Case FILELOG
				Case 1
				Select Case eventType
					Case SUCCESS
					oLog.WriteLine Now & " SUCCESS " & sMessage
					Case ERRORL
					oLog.WriteLine Now & " ERROR   " & sMessage
					Case Else
					'Exit Sub 
				End Select
				Case 2
				Select Case eventType
					Case SUCCESS
					oLog.WriteLine Now & " SUCCESS     " & sMessage
					Case ERRORL
					oLog.WriteLine Now & " ERROR       " & sMessage
					Case WARNING
					oLog.WriteLine Now & " WARNING     " & sMessage
					Case INFORMATION
					oLog.WriteLine Now & " INFORMATION " & sMessage
					Case Else
					'Exit Sub
				End Select
				Case 3
				Select Case eventType
					Case SUCCESS
					oLog.WriteLine Now & " SUCCESS     " & sMessage
					Case ERRORL
					oLog.WriteLine Now & " ERROR       " & sMessage
					Case WARNING
					oLog.WriteLine Now & " WARNING     " & sMessage
					Case INFORMATION
					oLog.WriteLine Now & " INFORMATION " & sMessage
					Case Else
					'Exit Sub
				End Select
				Case Else
				Exit Sub
			End Select
			
			oLog.close
			'Set oLog = Nothing
		Else
			
			'Log to array while path to logfile determined
			If IsArray(aLog) Then
				iArr = UBound(aLog) + 1
				ReDim Preserve aLog(iArr)
			Else
				ReDim aLog(0)
				iArr = UBound(aLog)
			End If
			
			Select Case FILELOG
				Case 1
				Select Case eventType
					Case SUCCESS
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " SUCCESS " & sMessage
					Case ERRORL
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " ERROR   " & sMessage
					Case Else
					ReDim Preserve aLog(iArr-1)
					Exit Sub
				End Select
				Case 2
				Select Case eventType
					Case SUCCESS
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " SUCCESS     " & sMessage
					Case ERRORL
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " ERROR       " & sMessage
					Case WARNING
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " WARNING     " & sMessage
					Case INFORMATION
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " INFORMATION " & sMessage
					Case Else
					Exit Sub
				End Select
				Case 3
				Select Case eventType
					Case SUCCESS
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " SUCCESS     " & sMessage
					Case ERRORL
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " ERROR       " & sMessage
					Case WARNING
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " WARNING     " & sMessage
					Case INFORMATION
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " INFORMATION " & sMessage
					Case Else
					Exit Sub
				End Select
				Case Else
				Exit Sub
			End Select
		End If
	End Sub
	
	Private Sub doEventLog(eventType, sMessage)
		'********************************************************************************
		' Purpose : Write Event to Eventlog.
		'           EventLog Level 0 = None 1 = Success/Error 2 = Full
		' Input   : eventType : Event type, Integer
		'           0 SUCCESS 1 ERROR (Const ERRORL) 2 WARNING 4 INFORMATION
		'           sMessage : Log message, String
		'********************************************************************************
		Select Case EVENTLOG
			Case 1
			Select Case eventType
				Case SUCCESS
				oShell.LogEvent eventType, sMessage
				Case ERRORL
				oShell.LogEvent eventType, sMessage
				Case Else
				Exit Sub
			End Select
			Case 2
			Select Case eventType
				Case SUCCESS
				oShell.LogEvent eventType, sMessage
				Case ERRORL
				oShell.LogEvent eventType, sMessage
				Case WARNING
				oShell.LogEvent eventType, sMessage
				Case INFORMATION
				oShell.LogEvent eventType, sMessage
				Case Else
				Exit Sub
			End Select
			Case 3
			Select Case eventType
				Case SUCCESS
				oShell.LogEvent eventType, sMessage
				Case ERRORL
				oShell.LogEvent eventType, sMessage
				Case WARNING
				oShell.LogEvent eventType, sMessage
				Case INFORMATION
				oShell.LogEvent eventType, sMessage
				Case Else
				Exit Sub
			End Select
			Case Else
			Exit Sub
		End Select
	End Sub
	
	Public Sub DelLog()
		'**********************************************************************************
		' Purpose : Delete obsolete logs
		' Input   : None
		'**********************************************************************************
		Dim currentSub : currentSub = "Class UserLog:DelLog"
		
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Log CleanUP Started"
		
		If iLogToKeep <> 0 Then
			LogEvent INFORMATION, "[" & currentSub & "] Call KeepOnlyFiles " & sLogRoot & " " & iLogToKeep
			KeepOnlyFiles sLogRoot, iLogToKeep
		End If
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Log CleanUP Complete"
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] " & APPNAME & " " & APPVERMAJOR &  "." & APPVERMINOR & " Completed in " & Helper.ExecTime(tStartTime, Now)
	End Sub
	
	Private Sub KeepOnlyFiles(sPath, iCount)
		'**********************************************************************************
		' Purpose : Delete obsolete files based upon date.
		'           n newest files are kept.
		' Input   : String (s) Path to root of files
		'           Integer : iCount : Number of folders to keep
		'**********************************************************************************
		'On Error Resume Next
		On Error Goto 0
		Err.Clear
		
		Dim cFiles
		Dim currentSub : currentSub = "Class UserLog:KeepOnlyFiles"
			
		Set oFldr = oFso.GetFolder(sPath)
		Helper.EchoErr Err, currentSub
		
		If Err.number <> 0 Then
			LogEvent ERRORL, "[" & currentSub & "] An Error occured connecting to: " & sPath & " old files must be deleted manually."
			Exit Sub
		Else
			LogEvent INFORMATION, "[" & currentSub & "] Connected to: " & sPath
		End If
		
		Set cFiles = oFldr.Files
		Helper.EchoErr Err, currentSub
		
		If Err.number <> 0 Then
			LogEvent ERRORL, "[" & currentSub & "] An Error occured while listing files in folder: " & sPath & ". Old files must be deleted manually."
			Exit Sub
		Else
			LogEvent INFORMATION, "[" & currentSub & "] Succsessfully listed files in folder: " & sPath
		End If
		
		iCnt = 0
		'build the date array
		For Each ofile In cFiles
			If InStr(oFile.Name, sLogFilePre) > 0 then
				ReDim Preserve aDate(iCnt)
				LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & oFile.DateCreated & " (Path: " & oFile.Path & ")"
				aDate(iCnt) = oFile.DateCreated
				iCnt = iCnt + 1
			end If 
		Next 
		LogEvent INFORMATION, "[" & currentSub & "] Creating array with fixed size: " & iCnt & ". Adding date of folders to array"
		
		On Error Resume Next
		Err.Clear
		'Check if number of files greater than i
		If (UBound(aDate)+1) <= iCount Then
			If Err.Number <> 0 Then
				LogEvent INFORMATION, "[" & currentSub & "] Number of file(s) in root is: 0. Number is less or equal to: " & iCount & " which is the number of file(s) to keep."
				Err.Clear
			Else
				LogEvent INFORMATION, "[" & currentSub & "] Number of file(s) in root is: " & UBound(aDate)+1 & ". Number is less or equal to: " & iCount & " which is the number of file(s) to keep."
			End If
			Exit Sub
		End If
		
		LogEvent INFORMATION, "[" & currentSub & "] Number of files in root is: " & UBound(aDate) +1 & ". Number is greater: " & iCount & " wihch is the number of file(s) to keep."
		
		'Sorting array by date, ascent sort order (The famous bubble sort)
		LogEvent INFORMATION, "[" & currentSub & "] Sorting dates in array, ascent sort order"
		For n = 0 To UBound(aDate) -1 
			For m = n+1 To UBound(aDate) 
				If aDate(m) < aDate(n) Then
					temp = aDate(m)
					aDate(m) = aDate(n)
					aDate(n) = temp
				End If
			Next
		Next
		
		'Just logging
		LogEvent INFORMATION, "[" & currentSub & "] Array sorted, result in ascent order: "
		For iCnt = 0 To UBound(aDate)
			LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & aDate(iCnt)
		Next
		
		'Cut array, keep (i) rows with date of folders wich is going to be deleted
		ReDim Preserve aDate(UBound(aDate) - iCount)
		LogEvent INFORMATION, "[" & currentSub & "] Array aDate cut, remaing rows are: "
		
		'Even more logging (those debuggers ;))
		For iCnt = 0 To UBound(aDate)
			LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & aDate(iCnt)
		Next
		
		LogEvent INFORMATION, "[" & currentSub & "] Start deleting file(s)..."
		For Each oFile In cFiles
			For iCnt = 0 To UBound(aDate)
				If oFile.DateCreated = aDate(iCnt) Then
					LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & aDate(iCnt) & " matches DateCreated on file: " & oFile.Path & " (Date=" & oFile.DateCreated & ")"
					Helper.DeleteFile oFile.Path
					Exit For
				End If
			Next
		Next
		
		Helper.EchoErr Err, currentSub
		
		If Err.Number = 0 Then
			LogEvent SUCCESS, "[" & currentSub & "] Deleted " & UBound(aDate)+1 & " obsolete log files" 
		End If
		
	End Sub
End Class
'######################################################################################
' Class Wrapper for Helper. Functions
'######################################################################################
Class HelperClass
	
	Public oShell,oExec,oFso,oFile,oFolder,oStdOut,Element,cmdOutput
	Private iSize,iInt,iCnt,iWordBreak,iCurrentLenth
	Public sScriptDir, sFilePath, sStreamData, sFolder, sUnc, sResult, sTempFile
	Private aResult
	Private bFound
	Private objRegExp, strPattern
	'GetDayTimeDate
	Public intSeconds, intMilliseconds
	'KeepOnly
	Private cCollection, oObject, sType, aDate, oFldr, n, m, temp, iCnt2, aDeleted()
	'GetFolderContent
	Private folder, items, item, FolderExists2, sType2, arrList(),i,sName
	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize
		Set oFso		= CreateObject("Scripting.FileSystemObject")
		Set oShell		= CreateObject("Wscript.Shell")
	End Sub
	
	Private Sub Class_Terminate
		Set oFso		= Nothing
		Set oShell		= Nothing
	End Sub
	'#---------------------------------------------------------------------------#
	
	Function EchoErr(myError, sProcedure)
		'**********************************************************************************
		' Purpose : Verify and Post Err message
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:EchoErr"
		
		If Err.Number <> 0 Then
			'WScript.echo "["& sProcedure & "] ERROR: Number:" & Err.Number & " : " & Err.Description
			UserLog.LogEvent ERRORL, "["& sProcedure & "] ERROR: Number:" &Err.Number & " : " & Err.Description
		End If
	End Function
	
	Sub import (sFileName)
		'**********************************************************************************
		' Purpose : Import an external script file 
		' Inputs  : Srting : sFileName : the file name
		' Output  : None
		'**********************************************************************************
		sScriptDir = oFso.GetParentFolderName(WScript.ScriptFullName)   
		sFilePath = oFso.BuildPath(sScriptDir,sFileName)   
		Const ForReading = 1   
		
		Set oFile = oFso.OpenTextFile(sFilePath,ForReading)   
		sStreamData = oFile.ReadAll()   
		ExecuteGlobal sStreamData   
	End Sub

	Public Function GetTempFilename()
		'**********************************************************************************
		' Purpose : Generate e temporary file, 
		' Inputs : None
		' Output : StringArray  : ShellRun : the actual output if any
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:GetTempFilename"
		
		GetTempFilename = oShell.ExpandEnvironmentStrings("%temp%") & oFso.GetTempName
	End Function	

	Public Function ShellRun(sCmd, iWinStyle, bWait)
		'**********************************************************************************
		' Purpose : Execute a command, It will then execute the command in a shell, 
		'           and capture the output into a file. That file is then read in and its 
		'           contents are returned as an Array() in the value the function returns.
		' Inputs : String : sCmd : The command to execute
		'		   Integer: iWinStyle : the window style (check VBS help for values)
		'		   Bool   : bWait : Wait for execution complete and return the output
		' Output : Array  : ShellRun : the actual output if any
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:ShellRun"
				
		sTempFile = GetTempFilename()
		On Error Resume Next 
		
		Dim sCmdOnly
		Dim sCmdPath
		Dim sCmdDrive
		Dim COMSPEC : COMSPEC = "%comspec% /c "
		
		'UserLog.LogEvent INFORMATION, "[" & currentSub & "] Command is : ["  & sCmd  & "]"
		
		If bWait Then
			oShell.Run COMSPEC &  sCmd  & " > " & sTempFile, iWinStyle, true
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Command Execute (Wait): [" & COMSPEC & sCmd  & " > " & sTempFile & "]"
			If Helper.FileExists(sTempFile,False) Then
				cmdOutput = Split(oFso.OpenTextFile(sTempFile,1).ReadAll,vbCRLF)
				If Err.Number = 62 Then
					UserLog.LogEvent ERRORL, "[" & currentSub & "] No Output result from Command Execute"
					'Clear error
					Err.Clear
				Else
					'Just Debug
					'UserLog.LogEvent INFORMATION, "[" & currentSub & "] Command has Output."
					'just For debug
					'For iCnt = 0 To UBound(cmdOutput)
					'	UserLog.LogEvent INFORMATION, "[" & currentSub & "] -" & cmdOutput(iCnt)
					'Next
				End If
	
				oFso.DeleteFile sTempFile, true
			Else
				UserLog.LogEvent ERRORL, "[" & currentSub & "] No Output File Command Execute"
			End If  
			ShellRun = cmdOutput
		Else 
			oShell.Run COMSPEC & sCmd, iWinStyle, false
			'UserLog.LogEvent INFORMATION, "[" & currentSub & "] Command Execute (No Wait): " & sCmd
			ShellRun = Array()
		End If 
			
		If Err.Number <> 0 Then
			Helper.EchoErr Err, currentSub
			'Clear error
			Err.clear
		End If
	End Function


	Public Function Validate(sStringToTest,aArray)
		'**********************************************************************************
		' Purpose : Check if the element is part of an array
		'**********************************************************************************
		bFound = False
		
		If (IsArray(aArray)) Then
			For Each Element In aArray				
				If LCase(sStringToTest) = LCase(Element) Then
					bFound = True
					Exit For
				End If
			Next 
		End If
		Validate = bFound
	End Function 
	
	Public Function FileMatchesPattern(strFileName, strWildCard) 
		'**********************************************************************************
		' Purpose : Function to test if a filename matches the wildcard characters passed. 
		' Converts a wildard (*.vbs) to a valid regular expression so that the file name 
		' can be tested for a match using a regular expression object.  
		' This negates the need to perform a lot of string parsing and comparison. 
		'         
		' Params:  strFileName   String, Holding the name of the file to test (must not include the path) 
		'          strWildCard   String, Holding the wildcard string used to compare the file with. (eg. "*.vbs") 
		' Returns: True          if the filename matches the wildcard, otherwise False. 
		'**********************************************************************************	  
        Set objRegExp = CreateObject("VBScript.RegExp") 
         
        ' Update the wildcard string to define a valid regular expression 
        strPattern = Replace(strWildCard, ".", "\.") 
        strPattern = Replace(strPattern, "*", ".*") 
        strPattern = "^" & strPattern & "$" 
         
        With objRegExp 
                .Pattern = strPattern 
                .IgnoreCase = True 
                .Global = True 
        End With 
         
        FileMatchesPattern = objRegExp.Test(strFileName) 
        'WScript.Echo "File: [" & strFileName & "] matches Pattern: [" & strPattern & "] = " &  FileMatchesPattern 
        Set objRegExp = Nothing 
	End Function 

	Public Function GetSize(varArray)
		'**********************************************************************************
		' Purpose : Check the array size
		'**********************************************************************************
		iSize = 0
		
		On Error Resume Next
		iSize = UBound(varArray)
		If Err.Number Then
			If Err.Number = 9 Then
				iSize = 0
			End If
		Else
			iSize = UBound(varArray) + 1
		End If
		GetSize = iSize
	End Function 
	
	Public Function IsNothing (Obj)
		'**********************************************************************************
		' Purpose : Check if object is Nothing
		'**********************************************************************************
		If TypeName(Obj) = "Nothing" Then
			IsNothing = True
		Else
			IsNothing = False
		End If
	End Function
	
	Function FileExists(sFilePath, bRequired)
		'**********************************************************************************
		' Purpose : Verify presense of a file, abort the script if the file is not present
		'		    and it's required.
		' Input   : string	: sFilePath 		: Path to file
		'           bool	: bRequired	: True|False
		' Return  : bool	: True|False
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:FileExists"
		
		If (oFso.FileExists(sFilePath)) Then
			'UserLog.LogEvent INFORMATION, "[" & currentSub & "] The file: " & sFilePath & " is present."
			FileExists = True
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] The file: " & sFilePath & " does not exist."
			FileExists = False
		End If
		
		If bRequired And FileExists = False Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] The file: " & sFilePath & " is required for futher processing of this script."
		End If
	End Function
	
	Function FolderExists(sFolderPath, bRequired)
		'**********************************************************************************
		' Purpose : Verify presense of a folder, abort the script if the folder is not present
		'		    and it's required.
		' Input   : string	: sFFolderPath 		: Path to folder
		'           bool	: bRequired	: True|False
		' Return  : bool	: True|False
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:FolderExistsExists"
		
		If (oFso.FolderExists(sFolderPath)) Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] The Folder: " & sFolderPath & " is present."
			FolderExists = True
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] The Folder: " & sFolderPath & " does not exist."
			FolderExists = False
		End If
		
		If bRequired And FolderExists = False Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] The folder: " & sFolderPath & " is required for futher processing of this script."
			Helper.Terminate
		End If
	End Function
	
	Function GetFolderContent(sFolderPath, bType, sMask)
		'**********************************************************************************
		' Purpose : Gets the content of a folder, abort the script if the folder is not present
		'		    and it's required.
		' Input   : string	: sFolderPath 		: Path to folder
		'			bool	: bType False:Files | True:Folder
		' Return  : Array	: Array of file/folder Names
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:GetFolderContent"
		
		If (oFso.FolderExists(sFolderPath)) Then
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] The Folder: " & sFolderPath & " is present."
			
			Set folder = oFso.GetFolder(sFolderPath)
			
			Select Case bType
				Case True
					sType2 = "Folder"
					Set items = folder.SubFolders
				Case False
					sType2 = "File"
					Set items = folder.Files
			End Select
			
			If items.count > 0 then
				i=0
				For each item In items
					If Helper.FileMatchesPattern (item.Name, sMask) then
						UserLog.LogEvent INFORMATION, "[" & currentSub & "] Listing " & sType2 & ": " & item.Name
						ReDim Preserve arrList(i)
						arrList(i) = item.Name
						i = i + 1
					End if
				Next
			End If 
			GetFolderContent = arrList

		Else
			UserLog.LogEvent ERRORL, "[" & currentSub & "] The Folder: " & sFolderPath & " does not exist."
			Set GetFolderContent = Array()
		End If
	End Function
		
	Function CreateFolder(sPath)
		'**********************************************************************************
		' Purpose : Create a folder
		' Input   : string	: sPath	: Path to folder
		' Return  : integer	:  -1 : folder creation error
		'						0 : folder allready exists
		'						1 : folder successfully created
		'**********************************************************************************
		On Error Resume next
		sFolder = vbnullString
		
		Dim currentSub : currentSub = "Class Helper:CreateFolder"
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Start creating directory structure: " & sPath

		'Find the starting point
		sFolder = sPath
		Do until oFso.FolderExists(sfolder)
			sFolder = Left(sFolder, InStrRev(sFolder, "\")-1)
		loop
		
		'Check and create the folder tree
		Do Until sFolder = sPath
			sFolder = Left(sPath, InStr(Len(sFolder) + 1, sPath & "\", "\"))
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Checking if folder exists: " & sFolder
			If Not oFso.FolderExists(sFolder) Then
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Creating folder: " & sFolder
				ofso.CreateFolder(sFolder)
				If Err.number <> 0 Then
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Error creating: " & sFolder & ". The error was: " & Err.description
					CreateFolder = false
					Exit Function
				Else 
					CreateFolder = true 
				End If
			Else 
				CreateFolder = true
			End If
		Loop
		CreateFolder = true
	End Function
	
	Function DeleteEmptyFolders(Spath,sRootPath)
		Dim sTmpFolder
		On error Resume next
		
		Set oFolder = oFso.getFolder(Spath)
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Error Deleting: " & sTmpFolder & ". The error was: " & Err.description
			DeleteEmptyFolders = false
			Exit Function
		End If
	
		'Check and Delete the folder tree
		Do Until LCase(oFolder.path) = LCase(sRootPath)
					
			If oFolder.subFolders.count = 0 Then
				'UserLog.LogEvent INFORMATION, "[" & currentSub & "] Deleting folder: " & oFolder.path
				sTmpFolder = oFolder.path
				Set oFolder = oFolder.ParentFolder
				ofso.DeleteFolder(sTmpFolder)
				If Err.number <> 0 Then
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Error Deleting: " & sTmpFolder & ". The error was: " & Err.description
					DeleteEmptyFolders = false
					Exit Function
				Else 
					DeleteEmptyFolders = true 
				End If
			Else 
				DeleteEmptyFolders = True
				Exit do
			End If
		Loop
	
	End Function
	
	function ReadFileLine(sPath, iLine)
		'**********************************************************************************
		' Purpose : Read a line from a text file
		' Input   : String : sPath : path to file
		'			integer : iLine : the line number to read
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:ReadFileLine"
		
		On Error Resume Next
		Err.clear
		
		If Helper.FileExists(sPath,False) Then
			aResult = Split(oFso.OpenTextFile(sPath,1).ReadAll,vbCRLF)
			
			'Just logging
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Read Output: "
			For iCnt = 0 To UBound(aResult)
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] -" & aResult(iCnt)
			Next

			If (iLine <= UBound(aResult)) Then
				ReadFileLine = aResult(iLine-1)
			End If
		End if		
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to Read File: " & sPath & ". The error was: " & Err.description & " (" & Err.number & ")"
		End If
	End Function
	
	Function DeleteFile(sPath)
		'**********************************************************************************
		' Purpose : Delete file
		' Input   : String : sPath : path to file
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:DeleteFile"
		
		'On Error Resume Next
		'Err.clear
		
		oFso.DeleteFile sPath, True
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to delete File: " & sPath & ". The error was: " & Err.description & " (" & Err.number & ")"
			DeleteFile = False
		Else
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] File: " & sPath & " was successfully deleted."
			DeleteFile = True 
		End If
	End Function
	
	Sub DeleteFolder(sPath)
		'**********************************************************************************
		' Purpose : Delete folder
		' Input   : String : sPath : path to folder
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:DeleteFolder"
		
		On Error Resume Next
		Err.clear
		
		oFso.DeleteFolder sPath, True
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to delete Folder: " & sPath & ". The error was: " & Err.description & " (" & Err.number & ")"
			DeleteFolder = False 
		Else
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] Folder: " & sPath & " was successfully deleted."
			DeleteFolder = True
		End If
	End Sub
	
	Function GetDayTimeDate()
		'**********************************************************************************
		' Purpose : Get Day,Date,Time
		' Input   : None
		' Return  : Current day of week + Date + Time
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:GetDayTimeDate"
		
		GetDayTimeDate = WeekdayName(Weekday(Now, vbUseSystemDayOfWeek),,vbUseSystemDayOfWeek) & " " & Date & " "
		
		intSeconds = (Hour(Now) * 3600) + (Minute(Now) * 60) + Second(Now) 
        intMilliseconds = Timer() - intSeconds 
        'intMilliseconds = Fix(intMilliseconds * 100) 
        intMilliseconds = Fix(intMilliseconds * 10000) 
		
		If CInt(Hour(Now)) < 10 Then
			GetDayTimeDate = GetDayTimeDate & "0" & Hour(Now) & "."
		Else
			GetDayTimeDate = GetDayTimeDate & Hour(Now) & "."
		End If
		
		If CInt(Minute(Now)) < 10 Then
			GetDayTimeDate = GetDayTimeDate & "0" & Minute(Now) & "."
		Else
			GetDayTimeDate = GetDayTimeDate & Minute(Now) & "."
		End If
		
		If CInt(Second(Now)) < 10 Then
			GetDayTimeDate = GetDayTimeDate & "0" & Second(Now)
		Else
			GetDayTimeDate = GetDayTimeDate & Second(Now)
		End If
		
		If InStr(GetDayTimeDate, "/") Then
			GetDayTimeDate = Replace(GetDayTimeDate, "/", ".")
		End If
		If InStr(GetDayTimeDate, "\") Then
			GetDayTimeDate = Replace(GetDayTimeDate, "\", ".")
		End If
		
		GetDayTimeDate = GetDayTimeDate & "_" & intMilliseconds
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Creating Date " & GetDayTimeDate
	End Function
	
	Function Random(iValue)
		'**********************************************************************************
		' Purpose : Create a random integer between 0 and i
		' Input   : integer		: iValue	: The max value
		' Return  : integer		: Random number between 0 and Input (i)
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:Random"
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Creating a random integer between: 0-" & iValue
		
		'Generate seed
		Randomize
		iInt = Int(iValue * Rnd)
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Random integer is: " & iInt
		Random = iInt
	End Function
	
	Sub Terminate()
		'**********************************************************************************
		' Puropose : Terminate the script, moving log to error directory.
		'            Inform the user about the error.
		' Input    : None
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:Terminate"
		
		UserLog.LogEvent ERRORL, "[" & currentSub & "] ABORT."
		WScript.quit
	End Sub
	
	Function BreakString (str, str2, length, fillSpaces) 
		'********************************************************************************
		' Purpose	: Break up a string into multiline string having a given length
		' Input   	: string	: str		: the input string
		'			  string	: str2		: the input string to append at the end
		'			  integer	: length	: the desired final length
		' 			  bool	: fillSpaces: option to fill spaces
		'********************************************************************************
		Dim currentSub : currentSub = "Class Helper:BreakString"
		
		'fill with spaces
		ReDim aResult(0)
		
		iCnt = 0
		'process the main string
		While (Len(str) >length) 
			iWordBreak = InStrRev(str, " ", length)
			'force a break if no word break detected
			If (iWordBreak = 0) Then
				iWordBreak = length
			End If
			ReDim Preserve aResult(iCnt)
			aResult(iCnt) = Left(str, iWordBreak-1)
			str = Right(str,Len(str)-iWordBreak)
			iCnt = iCnt + 1
		Wend
		'check if the remaining string can accept the append of str2
		If (Len(str)+Len(str2)+1 >length) Then
			ReDim Preserve aResult(iCnt)
			aResult(iCnt) = str
			If (Len(Trim(str2))> 0) Then
				ReDim Preserve aResult(iCnt+1)
				If fillSpaces Then
					aResult(iCnt+1) = Space(length - Len(str2)) & str2
				Else
					aResult(iCnt+1) = str2
				End If
			End If
		Else
			ReDim Preserve aResult(iCnt)
			If fillSpaces Then
				aResult(iCnt) = str & Space(length - Len(str)- Len(str2)) & str2
			Else
				If (Len(str2) > 0) Then
					aResult(iCnt) = str & Space(1) & str2
				Else	
					aResult(iCnt) = str
				End If
			End If
		End If
		BreakString = aResult
	End Function
	
	Function BuildString (str, length)
		'********************************************************************************
		' Purpose : fill up a string with space to a given length
		' Input   : string	: str		: the input string
		'			integer : length	: the desired final length
		'********************************************************************************
		Dim currentSub : currentSub = "Class Helper:BuildString"
		
		'fill with spaces
		iCurrentLenth = Len(str)
		str = str & Space(length - iCurrentLenth)
		
		buildString = str
	End Function
	
	Function ExecTime(StartTime,EndTime)
		'**********************************************************************************
		' Puropose : build a string in format xh xm xs
		' Input    : start time / end time
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:BuildTime"
		Dim iHour, iMinute, iSecond, iTotSeconds, endSeconds, startSeconds
	
		startSeconds = (Second(StartTime) + (Minute(StartTime) * 60) + ((Hour(StartTime) * 60)*60))
		endSeconds = (Second(EndTime) + (Minute(EndTime) * 60) + ((Hour(EndTime) * 60)*60))
		iTotSeconds = endSeconds - startSeconds 
		
		iHour     = Fix(iTotSeconds/3600)
		iMinute   = Fix((iTotSeconds - iHour*3600)/60)
		iSecond   = Fix(iTotSeconds - iMinute*60 - iHour*3600)
		
		ExecTime = iHour & "h " & iMinute & "m " & iSecond & "s "
	End Function 

	Function KeepOnly (sPath, iCount, iType)
		'**********************************************************************************
		' Purpose : Delete obsolete folders based upon creation date.
		'           n newest files are kept.
		' Input   : String (s) Path to root of folders
		'           Integer : iCount : Number of folders to keep
		'			Integer	: iType : 0 Files
		'							  1 Folders
		'							  2 Junctions
		'**********************************************************************************
		'On Error Resume Next
		On Error GoTo 0
		
		Dim currentSub : currentSub = "Class Helper:KeepOnly"
		
		Set oFldr = oFso.GetFolder(sPath)
		Helper.EchoErr Err, currentSub
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] An Error occured connecting to: " & sPath 
			KeepOnly = vbNull
			Exit function
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Connected to: " & sPath
		End If
		
		'Switch Folder or file Mode
		Select Case (iType)
			Case 0
				sType = "File"
				Set cCollection = oFldr.Files
				Helper.EchoErr Err, currentSub
			Case 1
				sType = "Folder"
				Set cCollection = oFldr.SubFolders
				Helper.EchoErr Err, currentSub
			Case  2
				sType = "Junction"
				Set cCollection = oFldr.SubFolders
				Helper.EchoErr Err, currentSub
		End Select
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] An Error occured while listing " & sType & " in folder: " & sPath & ". Old " & sType & " must be deleted manually."
			KeepOnly = vbNull 
			Exit function
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Succsessfully listed " & sType & " in folder: " & sPath
		End If
		
		'Check if number of files greater than i
		If cCollection.Count <= iCount Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Number of " & sType & " in root is: " & cCollection.Count & ". Number is less or equal to: " & iCount & " wich is the number of " & sType & " to keep."
			KeepOnly = vbNull 
			Exit function
		End If
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Number of " & sType & " in root is: " & cCollection.Count & ". Number is greater: " & iCount & " wich is the number of " & sType & " to keep."
		
		'ReDim array to number of folders
		ReDim aDate(cCollection.Count -1)
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Creating array with fixed size: " & cCollection.Count -1 & ". Adding date of " & sType & " to array"
		
		iCnt = 0
		
		'Add date creation of all objects to array
		For Each oObject In cCollection
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & oObject.DateCreated & " (Path: " & oObject.Path & ")"
			aDate(iCnt) = Array(oObject.DateCreated,oObject)
			iCnt = iCnt + 1
		Next
		
		'Sorting array by date, ascent sort order (The famous bubble sort)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Sorting dates in array, ascent sort order"
		For n = 0 To UBound(aDate) -1 
			For m = n+1 To UBound(aDate) 
				If aDate(m)(0) < aDate(n)(0) Then
					temp = aDate(m)
					aDate(m) = aDate(n)
					aDate(n) = temp
				End If
			Next
		Next
		
		'Just logging
'		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Array sorted, result in ascent order: "
'		For iCnt = 0 To UBound(aDate)
'			UserLog.LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & aDate(iCnt)(0) & " (Path: " & aDate(iCnt)(1).Path & ")"
'		Next
		
		'Cut array, keep (i) rows with date of folders wich is going to be deleted
		ReDim Preserve aDate(UBound(aDate) - iCount)
		ReDim aDeleted (UBound(aDate))
'		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Array aDate cut, remaing rows are: "
		
		'Even more logging (those debuggers ;))
'		For iCnt = 0 To UBound(aDate)
'			UserLog.LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & aDate(iCnt)(0) & " (Path: " & aDate(iCnt)(1).Path & ")"
'		Next
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Start deleting " & sType & "..."
		For iCnt2 = 0 To UBound(aDate)
			aDeleted (iCnt2)	= aDate(iCnt2)(1).Name
			Select Case (sType)
				Case "File"
					Helper.DeleteFile aDate(iCnt2)(1).Path
				Case "Folder"
					Helper.DeleteFolder aDate(iCnt2)(1).Path
				Case "Junction"
					Junction.DeleteJunction aDate(iCnt2)(1).ParentFolder.Path , aDate(iCnt2)(1).Name
			End Select
		Next
		
		Helper.EchoErr Err, currentSub
		
		If Err.Number = 0 Then
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] Deleted " & UBound(aDate)+1 & " obsolete " & sType & " Entries." 
		End If
		
		KeepOnly = aDeleted
	End function
End Class

Public Sub Class_Event(sSource, sEventType,ByVal bResult,ByVal values)
	'********************************************************************************
	' Purpose : Fire an event received from the child objects
	'********************************************************************************
	Dim currentSub : currentSub = "Main:Class_Event"
	
	If IsArray(values) Then
		values = Join(values,"|")
	ElseIf (values = vbNullString) Then
		values = "Null"
	End If 
	
	If (TypeName(DEBUG_CLASS_EVENTS) <> "Nothing") Then
		If (DEBUG_CLASS_EVENTS = True) Then
			WScript.Echo "EVENT FIRED [" & currentSub & "] source: " & sSource & " ; EventType:" & sEventType & " ; Result:" & bResult & " ; values:" & values
		End If
	End If 
End Sub

Sub Import (sFileName)
	'**********************************************************************************
	' Purpose : Import external file
	'**********************************************************************************
	Dim oFso, oFile
	Dim sScriptDir, sFilePath, sStreamData
	
	Set oFso		= CreateObject("Scripting.FileSystemObject")
	sScriptDir = oFso.GetParentFolderName(WScript.ScriptFullName)   
	sFilePath = oFso.BuildPath(sScriptDir,sFileName)   
	Const ForReading = 1   
	
	Set oFile = oFso.OpenTextFile(sFilePath,ForReading)   
	sStreamData = oFile.ReadAll()   
	ExecuteGlobal sStreamData   
End Sub